Package org.kie.internal.query

## Interface ParametrizedQueryBuilder<T>

- Type Parameters:
    `T` - The type of `ParametrizedQueryBuilder` instance being implemented. This type is here to facilitate the building of a fluent interface.
  All Known Subinterfaces:
    `AuditDateDeleteBuilder<T>`, `AuditDeleteBuilder<T>`, `AuditLogQueryBuilder<T,​R>`, `AuditTaskDeleteBuilder`, `AuditTaskQueryBuilder`, `ErrorInfoDeleteBuilder`, `ErrorInfoQueryBuilder`, `ExecutionErrorInfoDeleteBuilder`, `ExtendedParametrizedQueryBuilder<T,​R>`, `NodeInstanceLogDeleteBuilder`, `NodeInstanceLogQueryBuilder`, `ProcessIdQueryBuilder<T,​R>`, `ProcessInstanceIdQueryBuilder<T,​R>`, `ProcessInstanceLogDeleteBuilder`, `ProcessInstanceLogQueryBuilder`, `RequestInfoLogDeleteBuilder`, `RequestInfoQueryBuilder`, `TaskAuditQueryBuilder<T,​R>`, `TaskEventDeleteBuilder`, `TaskEventQueryBuilder`, `TaskSummaryQueryBuilder`, `TaskVariableDeleteBuilder`, `TaskVariableQueryBuilder`, `VariableInstanceLogDeleteBuilder`, `VariableInstanceLogQueryBuilder`

      public interface ParametrizedQueryBuilder<T>

  This is the base interface for all `ParametrizedQueryBuilder` implementations. It includes the basic query functions.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `T` | `and()` | Synonym for `intersect()`
    `T` | `clear()` | Clear all parameters and meta-criteria
    `T` | `equals()` | Results retrieved using query criteria added after this method is used, must exactly match the criteria given.
    `T` | `intersect()` | Synonym for `and()`
    `T` | `like()` | Deprecated. will be deleted in 7.0
    `T` | `maxResults​(int maxResults)` | Limit the number of results returned by the query to the specified maximum.
    `T` | `offset​(int offset)` | Limit the results returned by excluding the specified number of results (the offset), from the start of the result list.
    `T` | `or()` | Synonym for `union()`
    `T` | `regex()` | Query criteria which are added to the query after this method are regular expression (a.k.a "regex") criteria.
    `T` | `union()` | Synonym for `or()`

- - ### Method Detail

    - #### union

          T union()

      Synonym for `or()` Query criteria which are added to the query after this method are "OR" or "union" criteria. Since this is based on SQL, please remember that intersection operands have precedence over union operands. In other words,
      - `A or B and C == A or (B and C)`
      - `A and B or C == (A and B) or C`
      This is the default mode for all query builders.
      Returns:
        the current query builder instance

    - #### or

          T or()

      Synonym for `union()` Query criteria which are added to the query after this method are "OR" or "union" criteria. Since this is based on SQL, please remember that intersection operands have precedence over union operands. In other words,
      - `A or B and C == A or (B and C)`
      - `A and B or C == (A and B) or C`
      This is the default mode for all query builders.
      Returns:
        the current query builder instance

    - #### intersect

          T intersect()

      Synonym for `and()` Query criteria which are added to the query after this method are "AND" or "intersection" criteria. Since this is based on SQL, please remember that intersection operands have precedence over union operands. In other words,
      - `A or B and C == A or (B and C)`
      - `A and B or C == (A and B) or C`
      Returns:
        the current query builder instance

    - #### and

          T and()

      Synonym for `intersect()` Query criteria which are added to the query after this method are "AND" or "intersection" criteria. Since this is based on SQL, please remember that intersection operands have precedence over union operands. In other words,
      - `A or B and C == A or (B and C)`
      - `A and B or C == (A and B) or C`
      Returns:
        the current query builder instance

    - #### like

          @Deprecated
          T like()

      Deprecated.
      will be deleted in 7.0
      Query criteria which are added to the query after this method are regular expression (a.k.a "regex") criteria. In other words, the query will return results which match the regular expressions specified. Only String criteria may be added after using this method. In order to go back to adding normal or non-regex criteria, use the `equals()` method. The following characters may be used:
      - .
        - This character matches any single character.
      - *
        - This character matches zero or more characters.
      Returns:
        the current query builder instance

    - #### regex

          T regex()

      Query criteria which are added to the query after this method are regular expression (a.k.a "regex") criteria. In other words, the query will return results which match the regular expressions specified. Only String criteria may be added after using this method. In order to go back to adding normal or non-regex criteria, use the `equals()` method. The following characters may be used:
      - .
        - This character matches any single character.
      - *
        - This character matches zero or more characters.
      Returns:
        the current query builder instance

    - #### equals

          T equals()

      Results retrieved using query criteria added after this method is used, must exactly match the criteria given. If the `like()` method has been used, using this method will ensure that criteria added after this method are literally interpreted, and not seen as regular expressions. This is the default mode for all query builders.
      Returns:
        the current query builder instance

    - #### clear

          T clear()

      Clear all parameters and meta-criteria
      Returns:
        the current query builder instance

    - #### maxResults

          T maxResults​(int maxResults)

      Limit the number of results returned by the query to the specified maximum.
      Parameters:
        `maxResults` - The maximum number of results to return
      Returns:
        the current query builder instance

    - #### offset

          T offset​(int offset)

      Limit the results returned by excluding the specified number of results (the offset), from the start of the result list. Which results are excluded (offset) is dependent on the order of the results returned. See the orderBy(enum) methods as well as `#ascending()` and `#descending()`.
      Parameters:
        `offset` - The number of elements skipped before the first element in the result
      Returns:
        the current query builder instance